(function() {
	var filePath = "";
	var unzipPath = "";
	/*
	 * ダウンロード
	 */
	function download() {
		// ダウンロードオプション
		var options = {
			url : "http://www.applican.com/download/zip/sample/web.zip",
			timeout : 10,
			destination : "caches",
		};
		// ファイルダウンロード
		applican.utilities.download(options, progressCallback, successCallback, errorCallback);

		/**
		 * ダウンロードパーセンテージ
		 */
		function progressCallback(percentage) {
			// ダウンロードパーセンテージ
			document.getElementById("msg").value = "download percentage: " + percentage + "%";
		}
		
		/**
		 * ダウンロード成功
		 */
		function successCallback(path) {
			filePath = path;
			var dump = "download success path: " + path;
			document.getElementById("msg").value = dump;
		}
		
		/**
		 * ダウンロード失敗
		 */
		function errorCallback() {
			var dump = "download error";
			document.getElementById("msg").value = dump;
		}
	};

	/*
	 * ファイルの解凍
	 */
	function unzip() {

		if(!filePath) {
			return;
		}

		// 解凍オプション
		var options = {
			source : filePath,
			target : unzipPath
		};
		
		applican.utilities.unzip(options, successCallback, errorCallback);
		
		/**
		 * ファイルの解凍成功
		 */
		function successCallback(path){
			var dump = "unzip successCallback path : " + path;
			document.getElementById("msg").value = dump;
		}

		/**
		 * ファイルの解凍失敗
		 */
		function errorCallback(error){
			var dump = "unzip errorCallback\n";
			dump += "code:" + error.code + "\n";
			document.getElementById("msg").value = dump;
		}
	}
	
	/*
	 * 解凍パスを取得
	 */
	function getUnzipPath() {
		//ディレクトリパス取得
		applican.getApplicationCacheRoot(FilesRootSuccess, FilesRootError);

		function FilesRootSuccess(result){
			unzipPath = result;
		}

		function FilesRootError(){
			document.getElementById("msg").value = "ディレクトリパスの取得に失敗しました。";
		}
	}

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「ダウンロード」ボタン押下処理
		document.getElementById("download").addEventListener("touchend", download, false);
		// 「解凍」ボタン押下処理
		document.getElementById("unzip").addEventListener("touchend", unzip, false);
		// 解凍パスを取得
		getUnzipPath();
	});

})();
